/************************************************************************
    ppgLinearSurfaceClass.h:  Defines ppgLinearSurfaceClass.


    ppgLinearSurfaceClass:
        Holds information common to a group of compatible linear
        surfaces.


    Part of the PenguinPlay 2d library.  Please see LICENSE.TXT supplied
    with this library for copyright details.

    Copyright (C)    Adrian Ratnapala 1998.


    $Author: raka $
    $Date: 1998/11/25 10:06:11 $
    $Revision: 1.1 $
************************************************************************/


#ifndef _ppgDevice_h
#define _ppgDevice_h

#include "ppgCommon.h"
#include <PenguinPlay/ppgDevice.h>

class ppgLinearSurface;


//: Device for ppgLinearSurfaces.
//
// Primarily this gives us info about bitwise layout of the pixels
// and the access modes required to talk to the surfaces.
//
class ppgLinearDevice : public ppgDevice {
  //unsigned int access_width;
  //unsigned int access_align;
  
  /*FIX: bit shifting?  Or does that go in ColourMode?*/


  public:

  ppgLinearDevice();

  //_PP_GETSET(AccessWidth, access_width, unsigned int);
  //: (Minimum?) width for an read or write (bits).
  //_PP_GETSET(AccessAlign, access_align, unsigned int);
  //: All reads or writes have to be aligned on these boundaries.
  //FIX: that should not go there.  We must wait till we have
  //DirectBuffer devices.
  
  virtual void InitializeGC(ppgGC& gc)const;

  #ifdef PP_DEBUG
  virtual char* dbGetClassName()const{return "LINEAR_BLOCK_CLASS";}
  #endif
};


#endif // ppgLinearDevice_h
